/*+-----------------------------------------------------------------------
	ecu.c - Extended Calling Unit/Call Utility/Call UNIX/whatever
	wht@n4hgf.Mt-Park.GA.US

  Defined functions:
	main(argc,argv,envp)
	xmtr()

   "Now tell me, old man, what's your name?"
   "Holloway, sir. Charles William Holloway."
   "Oh yes, the town's librarian."
   "I have the honor, sir, and have had for many years."
   "I believe all that time spent living through other men's lives,
other men's dreams, what a waste."
   "Sometimes, a man can learn more from other men's dreams than he
can from his own.  Come visit me sir, if you wish to improve your
education and I may improve yours."  -- Something Wicked This Way Comes

------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:08-11-1991-19:56-wht@n4hgf-soup up -l for ISC vs. SCO */
/*:08-06-1991-13:02-wht@n4hgf-jpm@logixwi fix: HZ getenv test wrong sense */
/*:07-29-1991-17:57-wht@n4hgf-add memstat */
/*:07-25-1991-12:55-wht@n4hgf-ECU release 3.10 */
/*:07-17-1991-07:04-wht@n4hgf-avoid SCO UNIX nap bug */
/*:04-27-1991-01:52-wht@n4hgf-overhaul revision numbers */
/*:03-17-1991-13:44-wht@n4hgf-nice and uid revision */
/*:01-09-1991-22:31-wht@n4hgf-ISC port */
/*:11-30-1990-19:04-wht@n4hgf-new ttyinit parameter - see TTYINIT_... */
/*:11-28-1990-15:58-wht@n4hgf-add non-ansi terminal support */
/*:08-14-1990-20:39-wht@n4hgf-ecu3.00-flush old edit history */

#if !defined(XECU)
#include "ecu.h"
#include "esd.h"
#include "proc.h"
#include "ecukey.h"
#include "ecuxkey.h"
#include "termecu.h"
#include "patchlevel.h"
#undef NULL
#include <sys/param.h>

#if defined(sun) && defined(FASI)
#undef FRASI
#endif
#if defined(sun) && defined(MORSE)
#undef FRASI
#endif

char *getenv();

extern char *makedate;			/* temporary make date */
extern char *revstr;	/* ecunumrev.c */
extern char *revision_modifier; /* ecunumrev.c */
extern ESD *icmd_prompt;
extern char kbdeof;			/* current input EOF */
extern char kbdeol2;		/* current secondary input EOL */
extern char kbdeol;			/* current input EOL */
extern char kbderase;		/* current input ERASE */
extern char kbdintr;		/* current input INTR */
extern char kbdkill;		/* current input KILL */
extern char kbdquit;		/* current input QUIT */
extern char kbd_is_7bit;	/* keyboard has parity */
extern uint tcap_LINES;
extern uint tcap_COLS;
extern ulong colors_current;
extern int there_is_hdb_on_this_machine;
extern int tty_not_char_special;
extern int tty_is_ansi;
extern int tty_is_multiscreen;
extern char lopen_err_str[];

char *eculibdir = ECULIBDIR;
char curr_dir[CURR_DIRSIZ];		/* current working directory of process */
char hello_str[128];		/* msg printed upon BOJ */
char errmsg[128];
char modem_ctl_fname[128];
char initial_procedure[128] = "";
char *default_tty = DEFAULT_TTY;	/* configurable default tty name */
int init_proc_argc = 0;
char *init_proc_argv[MAX_PARGV];
int quiet = 0;			/* don't shut up is default */
int rcvr_pid = -1;		/* pid for rcvr process (-1 == no proc active) */
	/* ... -2 == special flag for modem control/timed-read procedures */
int xmtr_pid = 0;
int quit_on_init_proc_fail = 0;
int quit_on_init_proc_done = 0;
int rc_ep_has_run = 0;
int hz;					/* HZ from environ or sys/param.h */
ulong hzmsec;			/* clock period in msec rounded up */
struct timeb starting_timeb;
#ifdef MALLOC_3X
char *sbrk();
char *startbrk;
#endif

char *_rc = "_rc";	/* _rc.ep */

ushort geteuid();
ushort getuid();
ushort euid;
ushort uid;

/*+-----------------------------------------------------------------------
	xmtr() --  copy stdin to comm line

  THE INITIAL PROCESS EXECUTES THIS PROCESS UNTIL PROGRAM TERMINATION

  TTY input lines beginning with % have special significance
  (see ecuicmd.c)
------------------------------------------------------------------------*/
int
xmtr()
{
uchar xmtr_char;
uchar nlchar = NL;
void xmtr_SIGINT_handler();

	ttymode(1);
	xmtr_signals();
	while(1)
	{
/* bug somewhere ... may be SIGINT too rapidly causing SIG_IGN ????? */
		signal(SIGINT,xmtr_SIGINT_handler);	/* so make sure */
		xmtr_char = ttygetc(1);

		if(xmtr_char & 0x80)
		{
			kbd_escape(xmtr_char);
			continue;
		}

		lputc(xmtr_char);
		if(shm->Lfull_duplex == 0)		/* echo character if asked */
			write(TTYERR,(char *)&xmtr_char,1);

		if(xmtr_char == CRET)
		{
			if(shm->Ladd_nl_outgoing)
				lputc('\n');
			if(shm->Lfull_duplex == 0)
				write(TTYERR,(char *)&nlchar,1);
		}
	}		/* end of while we can read a character */

}	/* end of xmtr */

/*+-------------------------------------------------------------------------
	main(argc,argv,envp)

  main() program forks to create rcvr process; then main()
  becomes the xmtr process
------------------------------------------------------------------------*/
int
main(argc,argv,envp)
int argc;
char **argv;
char **envp;
{
int swchar;
int itmp;
ulong colors_save;
char *get_ttyname();
extern char *optarg;
extern int optind;

#ifdef MALLOC_3X
	(void)mallopt(M_MXFAST,256+4);
	(void)mallopt(M_NLBLKS,64);
	(void)mallopt(M_GRAIN,sizeof(ESD) + 8);
	startbrk = sbrk(0);
#endif

	setbuf(stderr,NULL);
	xmtr_signals();			/* catch xmtr signals */

	ftime(&starting_timeb);	/* get startup time */
	xmtr_pid = getpid();

/*
 * get this off quick, cause we'll be busy for a little while on 286
 */
	build_revision_string();

#if !defined(M_I286)
#if defined(WHT)
	sprintf(hello_str,"ecu %s (%s)",revstr,makedate);
#else
	sprintf(hello_str,"ecu %s (pid %d)",revstr,xmtr_pid);
#endif
#else
/* some kind of sprintf bug only seems to happen here on ODT-made I286 */
	strcpy(hello_str,"ecu ");
	strcat(hello_str,revstr);
#endif /* M_I286 */

	ff(se,"%s\n",hello_str);

/*
 * learn tick rate for various timers
 */
	if(getenv("HZ"))
		hz = atoi(getenv("HZ"));
	else
		hz = HZ;
	hzmsec = (ulong)(1000 / hz) + 2;

/*
 * if we are root (or setuid to root as we should be on 286 versions),
 * nice to very bad
 */
	uid = getuid();
	euid = geteuid();
	if((euid == 0) || (uid == 0))	/* if root running or prog text ... */
	{								/* ... sets to root, then grab gusto */
	int nice_value = 3;				/* go for hi priority */
	int old_nice = nice(0) + 20;
		nice(-old_nice + nice_value);
	}

/*
 * set uid to real uid
 */
	if(uid != euid)				/* if user not really who he say he is ... */
	{
		if(setuid(uid))			/* ... make him so */
		{
			ff(se,"\r\n");
			perror("setuid failed");
			ff(se,"\r\n");
			exit(-1);
		}
	}

	shm_init();				/* open shared segment */

	keyset_init();			/* intialize keyset */
	keyset_read("default");

	make_ecu_subdir();		/* needs to be very early before lots of init */

	get_curr_dir(curr_dir,sizeof(curr_dir));
	cd_array_init();		/* read %cd directory list */

	hdb_init();

	var_init();				/* initialize procedure variables */
	poutput_init();			/* initialize procedure output */

	icmd_prompt = esdalloc(64);
	set_default_escape_prompt();

/* init line variables */
	shm->Lline[0] = 0;				/* no line chosen yet */
	shm->Liofd = -1;				/* no line open now */
	shm->Lbaud = DEFAULT_BAUD_RATE;	/* see ecu.h */
	shm->Lparity = DEFAULT_PARITY;	/* see ecu.h */
	shm->Ltelno[0] = 0;				/* no telephone number for remote yet */
	shm->Llogical[0] = 0;			/* no logical name for remote yet */
	shm->Lrname[0] = 0;				/* no logical name for remote yet */
	shm->Ldescr[0] = 0;				/* no description for remote yet */
	shm->Lmodem_off_hook = 0;		/* assume modem on hook */
	shm->Ladd_nl_incoming = 0;		/* dont add nl to incoming cr */
	shm->Ladd_nl_outgoing = 0;		/* dont add nl to outgoing cr */
	shm->Lfull_duplex = 1;			/* assume full duplex */
	shm->Lmodem_already_init = 0;	/* modem has not been initialized */
	shm->Lxonxoff = IXON | IXOFF;	/* default to xon/xoff protocol */
	shm->xmtr_pid = getpid();
	shm->xmtr_ppid = getppid();
	shm->xmtr_pgrp = getpgrp(0);
	strcpy(shm->tty_name,get_ttyname());
	shm->shm_revision = SHM_REV;
	shm->ttyinit_param = TTYINIT_NORMAL;
	shm->terminating = 0;

	while((swchar = getopt(argc,argv,"c:p:l:b:hfdDteoANH")) != -1)
	{
		switch(swchar)
		{
			case 'b':
				if(valid_baud_rate(shm->Lbaud = atoi(optarg)) < 0)
				{
					ff(se,"invalid baud rate %u\n",shm->Lbaud);
					usage();
				}
				break;
			case 'c':
				strcpy(modem_ctl_fname,optarg);
				break;
			case 'l':
				strcpy(shm->Lline,"/dev/");
#if defined(M_SYSV)
			if(strncmp(optarg,"tty",4))
				strcat(shm->Lline,"tty");
			strcat(shm->Lline,optarg);
#else
			strcat(shm->Lline,optarg);
#endif /* M_SYSV */
				break;
			case 'p':
				strcpy(initial_procedure,optarg);
				break;
			case 'h': shm->Lfull_duplex = 0; break;
			case 'f': shm->Lfull_duplex = 1; break;
			case 'd': quit_on_init_proc_fail = 1; break;
			case 'D': quit_on_init_proc_done = 1; break;
			case 't': shm->Ladd_nl_incoming = 1;
					  shm->Ladd_nl_outgoing = 1; break;
			case 'e': shm->Lparity = 'e'; break;
			case 'o': shm->Lparity = 'o'; break;
			case 'A': shm->ttyinit_param = TTYINIT_FORCE_ANSI; break;
			case 'N': shm->ttyinit_param = TTYINIT_FORCE_NONANSI; break;
			case '?': usage();
		}
	}

/* check a few options for validity */
	if(!initial_procedure[0] &&
		(quit_on_init_proc_done || quit_on_init_proc_fail))
	{
		ff(se,"no -D/-d without -p\n");
		usage();
	}

	ttyinit(shm->ttyinit_param);	/* init console tty mode handler */
	ttymode(3);		/* put user console in `raw' mode but SIGINT terms prog */
	tcap_clear_screen();
#if defined(WHT) || defined(XTERM_FRIEND)
	xterm_title("ECU",0);
#endif
	ff(se,"%s\r\n",hello_str);

/* do the _rc.ep execution */
	if(find_procedure(_rc))
	{
		if(do_proc(1,&_rc))
		{
			if(quit_on_init_proc_fail || quit_on_init_proc_done)
				termecu(TERMECU_INIT_PROC_ERROR);
		}
	}
	rc_ep_has_run = 1;

/* check out line */
	if(!shm->Lline[0])
	{
		if(!there_is_hdb_on_this_machine)
			strcpy(shm->Lline,default_tty);
		else
		{
			choose_line(shm->Lbaud);
			if(!shm->Lline[0])
			{
				ff(se,"\r\n\n");
				tcap_stand_out();
				ff(se,"[no available Devices line at %u baud]",shm->Lbaud);
				tcap_stand_end();
				ff(se,"\r\n");
				strcpy(shm->Lline,default_tty);
				Nap(1000L);
			}
		}
	}

/* either present startup screen or run initial procedure or both */
	if(initial_procedure[0])
	{
		init_proc_argv[0] = initial_procedure;
		init_proc_argc = 1;
		for(itmp = optind; itmp < argc; itmp++)
		{
			if(*argv[itmp] != '-')
			{
				if(init_proc_argc == MAX_PARGV)
				{
					ff(se,"too many arguments to initial procedure\r\n");
					termecu(TERMECU_USAGE);
				}
				init_proc_argv[init_proc_argc++] = argv[itmp];
			}
		}

		if(tty_not_char_special)
			quit_on_init_proc_done = 1;
		else	/* rattle curses once - fixes quirk/bug I can't find */
		{
			windows_start();
			windows_end2();
			fflush(so);
		}

		if(do_proc(init_proc_argc,init_proc_argv))
		{
			if(quit_on_init_proc_fail || quit_on_init_proc_done)
				termecu(TERMECU_INIT_PROC_ERROR);
		}
		proc_file_reset();
		colors_save = colors_current;
		setcolor(colors_notify);
		fputs("[procedure finished]",se);
		setcolor(colors_save);
		ff(se,"\r\n");
		if(quit_on_init_proc_done)
			termecu(0);
		if(shm->Liofd < 0)
		{
			ff(se,"\r\n\n");
			tcap_stand_out();
			ff(se,"[no line attached by initial procedure]");
			tcap_stand_end();
			ff(se,"\r\n");
			if(quit_on_init_proc_fail)
				termecu(TERMECU_INIT_PROC_ERROR);
			tcap_stand_out();
			ff(se,"[press ESC to exit or SPACE for setup menu]");
			tcap_stand_end();
			itmp = ttygetc(0);
			ff(se,"\r\n");
			if(itmp == ESC)
				termecu(1);
			setup_screen((char *)0);
		}
		else
		{
			start_rcvr_process(0);
		}
	}
	else		/* no initial procedure */
	{
		setup_screen((optind < argc) ? argv[optind] : (char *)0);
	}

	/* enter xmtr operation */
	termecu(xmtr());

	/*NOTREACHED*/

}	/* end of main */

#endif /* XECU */
/* end of ecu.c */
/* vi: set tabstop=4 shiftwidth=4: */
