/*+-----------------------------------------------------------------------
	ecu.h -- TuckerWare Extended Calling Unit
	wht@n4hgf.Mt-Park.GA.US
------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:08-25-1991-14:39-wht@n4hgf-SVR4 port thanks to aega84!lh */
/*:08-13-1991-13:53-wht@n4hgf-UNIX and ISC nap() broken; XENIX still wins */
/*:08-09-1991-11:07-wht@n4hgf-configurable lock directory */
/*:07-25-1991-12:55-wht@n4hgf-ECU release 3.10 */
/*:01-25-1991-06:08-wht@n4hgf-mulltiple #define of ECULIBDIR */
/*:01-22-1991-14:33-wht@n4hgf-XENIX calloc/memmove fix */
/*:01-01-1991-21:36-wht@n4hgf-add GCC implies STDC */
/*:08-14-1990-20:39-wht@n4hgf-ecu3.00-flush old edit history */

#if defined(__STDC__)	/* sigh ... malloc and such types */
#define VTYPE void
#define VOLATILE volatile
#else
#define VTYPE char
#define VOLATILE
#endif

#if defined(__sun__) && !defined(sun)
#define sun
#endif

#if !defined(STDIO_H_INCLUDED)
#include <stdio.h>
#endif

#include <signal.h>
#include <ctype.h>
#include <sys/types.h>
#include <errno.h>
#include <sys/timeb.h>
#include <string.h>
#include <memory.h>
#include <sys/stat.h>
#include <fcntl.h>

#if !defined(OMIT_TERMIO_REFERENCES)
#if defined(sun)
#include <termio.h>
#define termio termios
#undef TCGETA
#undef TCSETA
#undef TCSETAW
#define TCGETA	TCGETS
#define TCSETA	TCSETS
#define TCSETAW	TCSETSW
#else
#include <termio.h>
#endif /* sun */
#endif /* OMIT_TERMIO_REFERENCES */

#if defined(sun) && defined(FASI)
#undef FASI
#endif
#if defined(sun) && defined(MORSE)
#undef MORSE
#endif

#if defined(M_UNIX)
#undef M_XENIX		/* we don't want this defined in UNIX world */
#undef NO_SELECT	/* UNIX select(S) works */
#pragma intrinsic(memcpy)	/* trust these intrinsics ... */
#pragma intrinsic(memset)	/* ... because we know how we use them */
#endif

#if defined(M_XENIX) && !defined(NO_SELECT)
#define NO_SELECT	/* the last 286 XENIX I saw (2.2.1) had no select */
#endif

#if !defined(NO_SELECT) && !defined(XECU)
#if defined(M_SYSV)	/* SCO */
# include <sys/select.h>
#else
# include <sys/time.h>
#endif
#endif

#if defined(M_SYSV) && !defined(SCO_TTY_NAMING)
#define SCO_TTY_NAMING
#endif

#define AUTO_DIAL_PROC	/* always on from now on */

#if defined(WHT)
#if !defined(NOMEMCHECK)
#define NOMEMCHECK
#endif
#endif

#include "termecu.h"
#include "ecushm.h"
#include "smap.h"

/* already in ecushm.h */
/* #if !defined(ushort) */
/* #define ushort unsigned short */
/* #endif */
/* #if !defined(uchar) */
/* #define uchar unsigned char */
/* #endif */
/* #if !defined(uint) */
/* #define uint unsigned int */
/* #endif */
/* #if !defined(ulong) */
/* #define ulong unsigned long */
/* #endif */

#if defined(MALLOC_3X)
#include <malloc.h>
#endif

long Nap();

/*
 * prototyes or external declarations
 *
 * "I took a silver needle [ANSI] and I put it into my arm.
 * It did some good. It did some harm.  But the nights were
 * cold and lonely and it almost kept me warm."
 * -- Leonard Cohen, _Songs from a Room_
 */
#include "stdio_lint.h"
#include "lint_args.h"

#ifdef XECU
# include "xecu.h"
#endif

/*
 * for better source line utilization, frequent use of
 * fprintf and stderr warrants the following
 */
#define pf	printf
#define	ff	fprintf
#define se	stderr
#define so	stdout

/*
 * useful macros
 */
#define max(a,b) ((a > b) ? a : b)
#define min(a,b) ((a < b) ? a : b)

/*
 * decide how to write to logfile
 */
#define LOGPUTC fputc	/* fputc() or putc() */

#define DEFAULT_BAUD_RATE	2400
#define DEFAULT_PARITY		0		/* 0=none, else 'e' or 'o' */
#define TTYIN	0
#define TTYOUT  1				/* ditto tty output */
#define TTYERR  2				/* ditty tty output error channel */

/*
 * xbell codes (see ecuxenix.c)
 */
#define  XBELL_DONE 		1		/* octaves or morse 'd' */
#define  XBELL_ATTENTION	2		/* morse .-.-.- ATTENTION */
#define  XBELL_C			3		/* morse -.-. C */
#define  XBELL_3T			4		/* --- really 'o' */

/*
 * lopen() and related routines error codes
 */
#define LOPEN_INVALID			-1		/* for invalid tty name */
#define LOPEN_UNKPID			-2		/* unknown pid using line */
#define LOPEN_LCKERR			-3		/* lock file open error */
#define LOPEN_NODEV				-4		/* device does not exist */
#define LOPEN_OPNFAIL			-5		/* could not access line */
#define LOPEN_ALREADY			-6		/* line already open */
#define LOPEN_ENABLED			-7		/* line enabled for login */
#define LOPEN_ENABLED_IN_USE	-8		/* line in use by incoming login */
#define LOPEN_DIALOUT_IN_USE	-9		/* line in use by another dial out */
#define LOPEN_NOPTY				-10		/* pty not supported */
#define LOPEN_WE_GOT_IT			-11		/* not really an error: we already
										 * own the line (used by check_utmp())
										 */

/*
 * current directory array size
 */
#define CURR_DIRSIZ 256

extern int errno;
extern char *sys_errlist[];
extern int sys_nerr;

/*
 * process IDs
 */
extern int rcvr_pid;
extern int xmtr_pid;

/*
 * both of the following are set by xmtr_SIGINT_handler()
 * 'sigint' reset by 1st detector/processor
 * 'proc_interrupt' reset/handled by procedure monitor
 *                  (execute_esd and execute_proc)
 */
extern int sigint;
/* extern int proc_interrupt; <------ force using modules to declare it */

/*
 * 'hz' is getenv("HZ"); that not found, the value from sys/param.h
 * 'hzmsec' is ceiling(clock period) in milliseconds
 */
extern int hz;				/* HZ from environ or sys/param.h */
extern ulong hzmsec;		/* clock period in msec rounded up */

/*
 * tty (comm line) variables that are not in shared memory
 */
#if defined(DECLARE_LINEVARS_PUBLIC)
char LLCKname[128];			/* lock file name */
#if !defined(OMIT_TERMIO_REFERENCES)
struct termio Ltermio;		/* attributes for the line to remote */
#endif
uchar Ldial_debug_level;
uchar Lmodem_sreg[20];		/* allow for more later */
#else
extern char LLCKname[];
#if !defined(OMIT_TERMIO_REFERENCES)
extern struct termio Ltermio;
#endif
extern uchar Ldial_debug_level;
extern uchar Lmodem_sreg[];
#endif

/*
 * lock file directory
 */
#if !defined(LOCK_DIR_NAME)
#if defined(M_SYSV)	/* SCO */
#define LOCK_DIR_NAME "/usr/spool/uucp"
#else
#if defined(sun) || defined(SVR4)
#define LOCK_DIR_NAME "/var/spool/locks"
#else
#if defined(ISC)
#define LOCK_DIR_NAME "/usr/spool/locks"
#else
# include "porting.attention.required.here"
#endif	/* ISC */
#endif	/* sun */
#endif	/* M_SYSV */
#endif  /* LOCK_DIR_NAME */
extern char *lock_dir_name;	/* defined in ecuLCK.c */

/*
 * default tty name
 */
#if !defined(DEFAULT_TTY)
#if defined(M_SYSV)	/* SCO */
#define DEFAULT_TTY	"/dev/tty1a"
#else
#if defined(sun)
#define DEFAULT_TTY	"/dev/cua0"
#else
#if defined(SVR4)
#define DEFAULT_TTY	"/dev/tty00"
#else
#if defined(ISC)
#define DEFAULT_TTY	"/dev/acu00"
#endif	/* ISC */
#endif	/* SVR4 */
#endif	/* sun */
#endif	/* M_SYSV */
#endif /*!defined(DEFAULT_TTY)
extern char *lock_dir_name;	/* defined in ecu.c */

/*
 * setcolor variables - see setcolor()
 */
extern ulong colors_current;
extern ulong colors_normal;
extern ulong colors_success;
extern ulong colors_alert;
extern ulong colors_error;
extern ulong colors_notify;

extern char *eculibdir;

/*
 * param to lgets_timeout in eculine.c
 */
typedef struct lrwt
{
	ulong to1;		/* timeout for 1st character (granularity 20) */
	ulong to2;		/* timeout for each next char (granularity 20) */
	int raw_flag;	/* !=0, rtn full buffer, ==0, rtn filtered hayes result */
	char *buffer;	/* buffer to fill */
	int bufsize;	/* size of buffer */
	int count;		/* from proc, count rcvd */
	char *delim;	/* ending string for lgets_timeout_or_delim */
	int echo_flag;	/* echo incoming chars to screen */
}	LRWT;


/* vi: set tabstop=4 shiftwidth=4: */
