/*+-------------------------------------------------------------------------
	ecucmd.h -- command definitions
	wht@n4hgf.Mt-Park.GA.US
--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:09-01-1991-18:12-wht@n4hgf2-add setline */
/*:09-01-1991-18:11-wht@n4hgf2-add setline */
/*:08-17-1991-16:41-wht@n4hgf-add kbdtest */
/*:07-29-1991-17:57-wht@n4hgf-add memstat */
/*:07-25-1991-12:55-wht@n4hgf-ECU release 3.10 */
/*:07-04-1991-20:07-wht@n4hgf-add procedure rlog cmd */
/*:05-21-1991-18:07-wht@n4hgf-add pushd/popd commands */
/*:03-20-1991-05:25-root@n4hgf-experimental eto command */
/*:03-16-1991-15:24-wht@n4hgf-add nice */
/*:08-14-1990-20:40-wht@n4hgf-ecu3.00-flush old edit history */

/* interactive command tokens */

#define CTax             1
#define CTbaud           2
#define CTbn             3
#define CTbreak          4
#define CTcd             5
#define CTclrx           6
#define CTda             7
#define CTdial           8
#define CTdo             9
#define CTduplex        10
#define CTexit          11
#define CTfi            12
#define CTfkey          13
#define CTgetf          14
#define CThangup        15
#define CThelp          16
#define CTllp           17
#define CTloff          18
#define CTlog           19
#define CTnl            21
#define CTnlin          22
#define CTnlout         23
#define CToa            24
#define CTparity        25
#define CTpcmd          26
#define CTpid           27
#define CTplog          28
#define CTptrace        29
#define CTputf          30
#define CTpwd           31
#define CTredial        32
#define CTrev           33
#define CTrk            34
#define CTrs            35
#define CTrtscts        36
#define CTrx            37
#define CTry            38
#define CTrz            39
#define CTsdname        40
#define CTsgr           41
#define CTsk            43
#define CTss            44
#define CTstat          45
#define CTsx            46
#define CTsy            47
#define CTsz            48
#define CTtime          50
#define CTts            51
#define CTtty           52
#define CTxa            53
#define CTxlog          54
#define CTxon           55
#if	defined(FASI)
#define CTfasi          56
#endif
#define CTnice          57
#define CTeto           58
#define CTpushd         59
#define CTpopd          60
#define CTmemstat       61
#define CTkbdtest       62

#define CTdummy1       120
#define CTdummy2       121
#define CTdummy3       122
#define CTdummy4       123

#define TOKEN_QUAN	128		/* for help package */

typedef int(*PFI)();

#if defined(HELPGEN)
#define Z {;}
#else
#define Z ;
#endif

int pcmd_baud() Z
int pcmd_break() Z
int pcmd_cd() Z
int pcmd_clrx() Z
int pcmd_cls() Z
int pcmd_color() Z
int pcmd_continue() Z
int pcmd_cursor() Z
int pcmd_delline() Z
int pcmd_dial() Z
int pcmd_do() Z
int pcmd_duplex() Z
int pcmd_echo() Z
int pcmd_eeol() Z
int pcmd_else() Z
int pcmd_exit() Z
int pcmd_expresp() Z
int pcmd_getf() Z
#if	defined(FASI)
int pcmd_fasi() Z
#endif
int pcmd_fchmod() Z
int pcmd_fclose() Z
int pcmd_fgetc() Z
int pcmd_fgets() Z
int pcmd_fkey() Z
int pcmd_flush() Z
int pcmd_fopen() Z
int pcmd_fputc() Z
int pcmd_fputs() Z
int pcmd_fread() Z
int pcmd_fseek() Z
int pcmd_fdel() Z
int pcmd_fwrite() Z
int pcmd_gosub() Z
int pcmd_gosubb() Z
int pcmd_goto() Z
int pcmd_gotob() Z
int pcmd_hangup() Z
int pcmd_hexdump() Z
int pcmd_home() Z
int pcmd_icolor() Z
int pcmd_insline() Z
int pcmd_ifge() Z
int pcmd_ifgt() Z
int pcmd_ifi() Z
int pcmd_ifle() Z
int pcmd_iflt() Z
int pcmd_ifnz() Z
int pcmd_ifs() Z
int pcmd_ifz() Z
int pcmd_lbreak() Z
int pcmd_lgets() Z
int pcmd_logevent() Z
int pcmd_lookfor() Z
/* int pcmd_mkdir() Z */
int pcmd_mkvar() Z
int pcmd_nap() Z
int pcmd_nice() Z
int pcmd_parity() Z
int pcmd_pclose() Z
int pcmd_plog() Z
int pcmd_popd() Z
int pcmd_popen() Z
int pcmd_prompt() Z
int pcmd_ptrace() Z
int pcmd_pushd() Z
int pcmd_putf() Z
int pcmd_return() Z
int pcmd_rk() Z
int pcmd_rlog() Z
int pcmd_rname() Z
int pcmd_rs() Z
int pcmd_rtscts() Z
int pcmd_rx() Z
int pcmd_ry() Z
int pcmd_rz() Z
int pcmd_scrdump() Z
int pcmd_send() Z
int pcmd_set() Z
int pcmd_setline() Z
int pcmd_sk() Z
int pcmd_ss() Z
int pcmd_sx() Z
int pcmd_sy() Z
int pcmd_system() Z
int pcmd_sz() Z
int pcmd_vidcolor() Z
int pcmd_vidnorm() Z
int pcmd_vidrev() Z
int pcmd_whilei() Z
int pcmd_whiles() Z
int pcmd_xon() Z

/* command classification */
#define ccG  1	/* general command */
#define ccC  2	/* comm command */
#define ccT  3	/* transfer command */
#define ccP  4	/* procedure-related command */

typedef struct p_cmd
{ 
	char *cmd;		/* command string */
	short mincnt;	/* min chars for match (0 if not interactive) */
	short token;	/* command number (if interactive) */
	char *descr;	/* command description (if interactive) */
	PFI proc;		/* procedure cmd handler (or 0) */
	short cmdclass;	/* cc{C,G,P,X} or 0 (for help processor) */
}	P_CMD;

#if !defined(DECLARE_P_CMD)
#if defined(NEED_P_CMD)
extern P_CMD icmd_cmds[];
#endif
#else
P_CMD icmd_cmds[] =
{
	{ "ax",		2,CTax,		"ascii char to hex/oct/dec",	0,			ccG},
	{ "baud",	2,CTbaud,	"set/display line baud rate",	pcmd_baud,	ccC},
	{ "bn",		2,CTbn,		"all console event alarm",		0,			ccG},
	{ "break",	2,CTbreak,	"send break to remote",			pcmd_break,	ccC},
	{ "cd",		2,CTcd,		"change current directory",		pcmd_cd,	ccG},
	{ "clrx",	2,CTclrx,	"simulate XON from remote",		pcmd_clrx,	ccC},
	{ "cls",	0,0,		"",								pcmd_cls,	0  },
	{ "color",	0,0,		"",								pcmd_color,	0  },
	{ "continue",0,0,		"",								pcmd_continue,0},
	{ "cursor",	0,0,		"",								pcmd_cursor,0  },
	{ "da",		2,CTda,		"decimal to ascii char",		0,         ccG},
	{ "dial",	1,CTdial,	"dial remote destination",		pcmd_dial, ccC},
	{ "delline",0,0,		"",								pcmd_delline,0 },
	{ "do",		2,CTdo,		"perform procedure",			pcmd_do,   ccP},
	{ "duplex",	2,CTduplex,	"set/display duplex",			pcmd_duplex,ccC},
	{ "echo",	0,0,		"",								pcmd_echo,  0  },
	{ "eeol",	0,0,		"",								pcmd_eeol,  0  },
	{ "else",	0,0,		"",								pcmd_else,  0  },
	{ "eto",	3,CTeto,	"ESC/fkey timeout",				0,         ccG},
	{ "exit",	2,CTexit,	"hang up, exit program",		pcmd_exit, ccG},
	{ "expresp",0,0,		"",								pcmd_expresp,0 },
#if	defined(FASI)
	{ "fasi",	2,CTfasi,	"FAS/i driver control",			pcmd_fasi,	ccC},
#endif
	{ "fchmod",	0,0,		"",								pcmd_fchmod,0  },
	{ "fclose",	0,0,		"",								pcmd_fclose,0  },
	{ "fdel",	0,0,		"",								pcmd_fdel,  0  },
	{ "fgetc",	0,0,		"",								pcmd_fgetc, 0  },
	{ "fgets",	0,0,		"",								pcmd_fgets, 0  },
	{ "fi",		2,CTfi,		"send text file to line",		0,         ccG },
	{ "fkey",	2,CTfkey,	"function key definition",		pcmd_fkey, ccG },
	{ "flush",	0,0,		"",								pcmd_flush, 0  },
	{ "fopen",	0,0,		"",								pcmd_fopen, 0  },
	{ "fputc",	0,0,		"",								pcmd_fputc, 0  },
	{ "fputs",	0,0,		"",								pcmd_fputs, 0  },
	{ "fread",	0,0,		"",								pcmd_fread, 0  },
	{ "fseek",	0,0,		"",								pcmd_fseek, 0  },
	{ "fwrite",	0,0,		"",								pcmd_fwrite,0  },
	{ "getf",	0,0,		"",								pcmd_getf,  0  },
	{ "gosub",	0,0,		"",								pcmd_gosub, 0  },
	{ "gosubb",	0,0,		"",								pcmd_gosubb,0  },
	{ "goto",	0,0,		"",								pcmd_goto,  0  },
	{ "gotob",	0,0,		"",								pcmd_gotob, 0  },
	{ "hangup",	2,CThangup,	"hang up modem",				pcmd_hangup,ccC},
	{ "help",	2,CThelp,	"invoke help",					0,         ccG },
	{ "hexdump",0,0,		"",								pcmd_hexdump,0 },
	{ "home",	0,0,		"",								pcmd_home,  0  },
	{ "icolor",	0,0,		"",								pcmd_icolor,0  },
	{ "ifge",	0,0,		"",								pcmd_ifge,  0  },
	{ "ifgt",	0,0,		"",								pcmd_ifgt,  0  },
	{ "ifi",	0,0,		"",								pcmd_ifi,   0  },
	{ "ifle",	0,0,		"",								pcmd_ifle,  0  },
	{ "iflt",	0,0,		"",								pcmd_iflt,  0  },
	{ "ifnz",	0,0,		"",								pcmd_ifnz,  0  },
	{ "ifs",	0,0,		"",								pcmd_ifs,   0  },
	{ "ifz",	0,0,		"",								pcmd_ifz,   0  },
	{ "insline",0,0,		"",								pcmd_insline,0 },
	{ "kbdtest",4,CTkbdtest,"",								0,          0  },
	{ "lbreak",	0,0,		"",								pcmd_lbreak,0  },
	{ "llp",	2,CTllp,	"set session log to /dev/lp",	0,         ccG },
	{ "lgets",	0,0,		"",								pcmd_lgets, 0  },
	{ "loff",	3,CTloff,	"turn off session logging",		0,         ccG },
	{ "log",	3,CTlog,	"session logging control",		0,         ccG },
	{ "logevent",0,0,		"",								pcmd_logevent,0},
	{ "lookfor",0,0,		"",								pcmd_lookfor,0 },
#if defined(MALLOC_3X)
	{ "memstat",3,CTmemstat,"",								0,          0  },
#endif
/*	{ "mkdir",	3,CTmkdir,	"mkdir <dirname>",				pcmd_mkdir, ccG}, */
	{ "mkvar",	0,0,		"",								pcmd_mkvar, 0  },
	{ "nap",	0,0,		"",								pcmd_nap,   0  },
	{ "nice",	2,CTnice,	"change process nice (0-39)",	pcmd_nice,  0  },
	{ "nl",		2,CTnl,		"display CR/LF mapping",		0,         ccC },
	{ "nlin",	3,CTnlin,	"set receive CR/LF mapping",	0,         ccC },
	{ "nlout",	3,CTnlout,	"set transmit CR/LF mapping",	0,         ccC },
	{ "oa",		2,CToa,		"octal to ascii char",			0,         ccG },
	{ "parity",	3,CTparity,	"set/display line parity",		pcmd_parity,ccC},
	{ "pclose",	0,0,		"",								pcmd_pclose,0  },
	{ "pcmd",	2,CTpcmd,	"execute a procedure command",	0,         ccP },
	{ "pid",	2,CTpid,	"display process ids",			0,         ccG },
	{ "plog",	2,CTplog,	"control procedure logging",	pcmd_plog, ccP },
	{ "popd",	2,CTpopd,	"pop to previous directory",	pcmd_popd, ccG },
	{ "popen",	0,0,		"",								pcmd_popen, 0  },
	{ "prompt",	0,0,		"",								pcmd_prompt,0  },
	{ "ptrace",	2,CTptrace,	"control procedure trace",		pcmd_ptrace,ccP},
	{ "pushd",	2,CTpushd,	"push to new directory",		pcmd_pushd, ccG},
	{ "putf",	0,0,		"",								pcmd_putf,  0  },
	{ "pwd",	2,CTpwd,	"print working directory",		0,         ccG },
	{ "redial",	3,CTredial,	"redial last number",			0,         ccC },
	{ "return",	0,0,		"",								pcmd_return,0  },
	{ "rev",	3,CTrev,	"ecu revision/make date",		0,         ccG },
	{ "rk",		2,CTrk,		"receive via C-Kermit",			pcmd_rk,   ccT },
	{ "rlog",	0,0,		"",								pcmd_rlog,  0  },
	{ "rname",	0,0,		"",								pcmd_rname, 0  },
	{ "rs",		2,CTrs,		"receive via SEAlink",			pcmd_rs,   ccT },
	{ "rtscts",	3,CTrtscts,	"control RTS/CTS flow control",	pcmd_rtscts,ccC},
	{ "rx",		2,CTrx,		"receive via XMODEM/CRC",		pcmd_rx,   ccT },
	{ "ry",		2,CTry,		"receive via YMODEM Batch",		pcmd_ry,   ccT },
	{ "rz",		2,CTrz,		"receive via ZMODEM/CRC32",		pcmd_rz,   ccT },
	{ "scrdump",0,0,		"",								pcmd_scrdump,0 },
	{ "sdname",	3,CTsdname,	"select screen dump name",		0,         ccC },
	{ "send",	0,0,		"",								pcmd_send,  0  },
	{ "set",	0,0,		"",								pcmd_set,   0  },
	{ "setline",0,0,		"",								pcmd_setline,0 },
	{ "sgr",	2,CTsgr,	"send command/get response",	0,         ccC },
	{ "sk",		2,CTsk,		"send via C-Kermit",			pcmd_sk,   ccT },
	{ "ss",		2,CTss,		"send via SEAlink",				pcmd_ss,   ccT },
	{ "stat",	2,CTstat,	"general status",				0,         ccG },
	{ "sx",		2,CTsx,		"send via XMODEM/CRC",			pcmd_sx,   ccT },
	{ "sy",		2,CTsy,		"send via YMODEM Batch",		pcmd_sy,   ccT },
	{ "system",	0,CTsy,		"",								pcmd_system,0  },
	{ "sz",		2,CTsz,		"send via ZMODEM/CRC32",		pcmd_sz,   ccT },
	{ "time",	2,CTtime,	"time of day",					0,         ccG },
	{ "ts",		2,CTts,		"termio display",				0,         ccC },
	{ "tty",	2,CTtty,	"console tty name",				0,         ccG },
	{ "vidcolor",0,0,		"",								pcmd_vidcolor,0},
	{ "vidnorm",0,0,		"",								pcmd_vidnorm,0 },
	{ "vidrev",	0,0,		"",								pcmd_vidrev,0  },
	{ "whilei",	0,0,		"",								pcmd_whilei,0  },
	{ "whiles",	0,0,		"",								pcmd_whiles,0  },
	{ "xa",		2,CTxa,		"hex to ascii char",			0,         ccG },
	{ "xlog",	2,CTxlog,	"protocol packet logging",		0,         ccT },
	{ "xon",	2,CTxon,	"control xon/xoff flow control",pcmd_xon,  ccC },
/* these cmds are interecepted by special code in ecucmd.h and appear
 * here only so they will be picked up by the help system.
 */
	{ "!",		1,CTdummy1,	"execute shell (tty)",			0,         ccG },
	{ "$",		1,CTdummy2,	"execute shell (comm line)",	0,         ccG },
	{ "-",		1,CTdummy3,	"execute program",				0,         ccG },
	{ "?",		1,CTdummy4,	"get help",						0,         ccG },
	{ "",		0,-1,"",0,0 }	/* list ends with token value of -1 */
};
#endif

/* end of ecucmd.h */
/* vi: set tabstop=4 shiftwidth=4: */
