/*+-----------------------------------------------------------------------
	ecunumrev.c - revision numbers
	wht@n4hgf.Mt-Park.GA.US
------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:08-28-1991-14:07-wht@n4hgf2-SVR4 cleanup by aega84!lh */
/*:08-25-1991-14:39-wht@n4hgf-SVR4 port thanks to aega84!lh */
/*:07-25-1991-12:56-wht@n4hgf-ECU release 3.10 */
/*:07-12-1991-14:14-wht@n4hgf-GCC140 differentiation */
/*:04-27-1991-01:52-wht@n4hgf-overhaul revision numbers */
/*:08-14-1990-20:40-wht@n4hgf-ecu3.00-flush old edit history */

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include "patchlevel.h"

/*
 * avoid ecu.h - a couple of duplicate decisions here
 */
#if defined(M_UNIX)
#undef M_XENIX
#define NO_SELECT
#endif

#ifdef WHT
char *numeric_revision = "x3.73";
#else
char *numeric_revision = "x3";
#endif
char *revstr = "";

/*+-------------------------------------------------------------------------
	build_revision_string()
--------------------------------------------------------------------------*/
void
build_revision_string()
{
char s128[128];

	sprintf(s128,"%s.%02d-",numeric_revision,PATCHLEVEL);

#if defined(M_I286)
	strcat(s128,"286");
#else
#if defined(M_I386) || defined(i386) && (!defined(sun) && !defined(SVR4))
	strcat(s128,"386");
#	if defined(M_XENIX)
#		if defined(NO_SELECT)
			 strcat(s128,"n");
#		else
			 strcat(s128,"s");
#		endif /* NO_SELECT */
#	endif /* M_XENIX */
#	if defined(M_UNIX)
		strcat(s128,"u");
#	endif /* M_UNIX */
#else
#if defined(sun)
	strcat(s128,"sun");
#else
#if defined(SVR4)
	strcat(s128,"SVR4");
#else
# include "porting.attention.needed.here"
#endif /* SVR4 */
#endif /* sun */
#endif /* M_I386 || i386 */
#endif /* M_I286 */

#if defined(__GNUC__)
#if defined(GCC140)
	strcat(s128,"-G");
#else
	strcat(s128,"-g");
#endif
#if defined(__STDC__)
	strcat(s128,"A");
#endif
#endif /*  */

#ifdef WHT
	strcat(s128,"*");
#endif /* WHT */

	strcat(s128," wht@n4hgf");

	if(!(revstr = malloc(strlen(s128) + 1)))
	{
		fprintf(stderr,"out of memory so early\?\?!\n");
		exit(255);
	}
	strcpy(revstr,s128);

}	/* end of build_revision_string */

/* vi: set tabstop=4 shiftwidth=4: */
