/*+-----------------------------------------------------------------------
	ecupde.h - phone directory entry definition
	wht@n4hgf.Mt-Park.GA.US
------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:07-25-1991-12:56-wht@n4hgf-ECU release 3.10 */
/*:06-01-1991-23:53-wht@n4hgf-use PDE_..._LEN identifiers */
/*:08-14-1990-20:40-wht@n4hgf-ecu3.00-flush old edit history */

#define PDE_LOGICAL_LEN		10
#define PDE_TELNO_LEN		20
#define PDE_TTY_LEN			15
#define PDE_DESCR_LEN		40

#ifdef futures
#define PDE_FC_NONE			0	/* no FAS: none   FAS: RTS/CTS */
#define PDE_FC_XON_XOFF		1	/* XON/XOFF */
#define PDE_FC_RTS_CTS		2	/* no FAS: SCO RTS/CTS */
#endif

typedef struct phone_directory_entry
{
	struct phone_directory_entry *next;
	struct phone_directory_entry *prev;
	uint baud;				
	short parity;						/* 0,'e','o', maybe 'm','s' */
	ushort redial;						/* if non-zero, marked for redial */
	char logical[PDE_LOGICAL_LEN + 1];	/* logical name of remote */
	char telno[PDE_TELNO_LEN + 1];		/* telno for remote or null */
	char tty[PDE_TTY_LEN + 1];			/* ttyname for access */
	char descr[PDE_DESCR_LEN + 1];		/* description of remote */
#ifdef futures
	uint zwindw_size;					/* default ZMODEM window size */
	uchar flow_control;					/* PDE_FC_... flow control */
#endif
	uchar debug_level;					/* -x debug level for dialer */
}	PDE;

/* vi: set tabstop=4 shiftwidth=4: */
/* end of ecupde.h */
