#define SHM_REV	0x0CDEF0008L	/* high 16-bits unique, low=revision */
/*+-------------------------------------------------------------------------
	ecushm.h -- ecu XENIX shared data segment
	wht@n4hgf.Mt-Park.GA.US
--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:08-21-1991-01:34-wht@n4hgf-FAR depends only on M_I286 */
/*:07-25-1991-12:56-wht@n4hgf-ECU release 3.10 */
/*:12-19-1990-17:09-wht@n4hgf-make cursor variables unsigned */
/*:11-30-1990-19:01-wht@n4hgf-add ttyinit_param */
/*:11-28-1990-17:43-wht@n4hgf-move cursor_y, cursor_x to right after revision */
/*:08-14-1990-20:40-wht@n4hgf-ecu3.00-flush old edit history */

#if defined(M_I286)
#define FAR far
#else
#define FAR
#endif

#if !defined(ushort)
#define ushort unsigned short
#endif
#if !defined(uchar)
#define uchar unsigned char
#endif
#if !defined(uint)
#define uint unsigned int
#endif
#if !defined(ulong)
#define ulong unsigned long
#endif

/* ttyinit() parameters */
#define TTYINIT_NORMAL			0	/* must be zero */
#define TTYINIT_FORCE_ANSI		1	/* must be non-zero */
#define TTYINIT_FORCE_NONANSI	2	/* must be non-zero */

#define SHM_STRLEN	256
typedef struct ecu_sds
{
	uchar screen[43][80];
	ulong shm_revision;
	uint cursor_y;			/* program-maintained receive cursor */
	uint cursor_x;			/* program-maintained receive cursor */
	ushort scr_lines;		/* lines in use */
	ushort scr_cols;		/* columns in use */
	ushort scr_size;		/* screen size (lines * cols) */
	ushort terminating;		/* made one when ECU terminating */
	/* xmtr to rcvr communication area */
	int xcmd;				/* signal from xmtr to rcvr SIGUSR2 */
	int xi1;
	int xi2;
	int xi3;
	char xs1[SHM_STRLEN];
	/* rcvr to xmtr communication area */
	int rcmd;				/* signal from rcvr to xmtr SIGUSR2 */
	int ri1;
	int ri2;
	char rs1[SHM_STRLEN];
	ulong rcvd_chars;		/* rcvr char count */
	ulong rcvd_chars_this_connect;	/* count since last connect */
	ulong xmit_chars;		/* xmit char count */
	ulong xmit_chars_this_connect;	/* count since last connect */
	int Ladd_nl_incoming;	/* when in ksr mode, add nl to cr on receive */
	int Ladd_nl_outgoing;	/* when in ksr mode, add nl to cr on xmit */
	int Lfull_duplex;		/* if non-zero, full duplex else half */
	int Liofd;				/* file descriptor for line */
	int Lmodem_already_init;/* true if modem already initialized */
	int Lmodem_off_hook;	/* we try to keep accurate */
	int Lparity;			/* 0==NONE, 'e' == even, 'o' == odd */
	uint Lbaud;				/* baud rate */
	char Ldescr[64];		/* description of remote */
	char Lline[64];			/* /dev/ttyname for outgoing line */
	char Llogical[64];		/* logical name of remote (from dial dir) */
	char Lrname[64];		/* logical name of remote (settable) */
	long Loff_hook_time;	/* time() at connect */
	char Ltelno[20];		/* telephone number for remote or null */
	ushort Lxonxoff;		/* status of line IXON and IXOFF */
	int xmtr_pid;			/* transmitter process pid */
	int xmtr_ppid;			/* transmitter process' parent's pid */
	int xmtr_pgrp;			/* transmitter process group */
	char tty_name[63];		/* comm line name (not console) */
	uchar ttyinit_param;	/* see TTYINIT_... above and ttyinit() */
	ulong friend_space[128];/* space for friend programs */
} ECU_SDS;

extern ECU_SDS FAR *shm;		/* shared segment pointer */

/* vi: set tabstop=4 shiftwidth=4: */
/* end of ecushm.h */
